#include<cstdio>
#include<cstdlib>
#include<cmath>
#include<cassert>
#include<ctime>
#include<string>
#include<vector>
#include<algorithm>
#define infile "carti.in"
#define tmax 100

using namespace std;

struct test
{
  int t, n, l;
} t[tmax];
int nr; //tests number

inline int randomValue(int a, int b)
{
  return (rand()%(b-a+1)) + a;
}

string makeString(int x)
{
  if(!x) return "0";
  string str;
  while(x)
    str = char((x%10) + '0') + str, x /= 10;
  return str;
}

void init()
{
  nr=20;
  t[1].t=1;     t[1].n=7;      t[1].l=31;
  t[2].t=13;    t[2].n=13;     t[2].l=10*1000;
  t[3].t=3;     t[3].n=23;     t[3].l=100;
  t[4].t=13;    t[4].n=29;     t[4].l=100;
  t[5].t=5;     t[5].n=31;     t[5].l=100;
  t[6].t=13;    t[6].n=50;     t[6].l=500;
  t[7].t=7;     t[7].n=66;     t[7].l=500;
  t[8].t=13;    t[8].n=100;    t[8].l=500;
  t[9].t=9;     t[9].n=66;     t[9].l=500;
  t[10].t=13;   t[10].n=100;   t[10].l=500;
  t[11].t=10;   t[11].n=66;    t[11].l=500;
  t[12].t=13;   t[12].n=100;   t[12].l=500;
  t[13].t=11;   t[13].n=66;    t[13].l=10*1000;
  t[14].t=13;   t[14].n=100;   t[14].l=10*1000;
  t[15].t=12;   t[15].n=66;    t[15].l=10*1000;
  t[16].t=13;   t[16].n=100;   t[16].l=10*1000;
  t[17].t=13;   t[17].n=66;    t[17].l=10*1000;
  t[18].t=13;   t[18].n=100;   t[18].l=10*1000;
  t[19].t=13;   t[19].n=66;    t[19].l=10*1000;
  t[20].t=13;   t[20].n=100;   t[20].l=10*1000;
}

int isqrt(int n, double p) {
    int ret = 0;

    while (pow(ret+1, p) <= n) ret++;

    return ret;
}

vector <int> generateBulan(int n, int &l) {

    vector <int> v;
    int newL = 0;
    int maxV = 0;

    for (int i = 0; i < isqrt(n, 1.5); ++i) {
      v.push_back(1);
    }

    for (int i = isqrt(n, 1.5); i < n; ++i) {
      v.push_back(randomValue(1, isqrt(l, 1.3)));
      maxV = max(maxV, v.back());

      if (newL + v.back() <= l && randomValue(0, isqrt(n, 2)) == 0) {
          newL += v.back();
      }
    }

    if (newL > 0) {
        newL += randomValue(0, min(l-newL, isqrt(n, 2)));
        while(newL < maxV) newL += v[randomValue(isqrt(n, 1.5), n-1)];
        l = min(l, newL);
    }

    return v;
}

vector <int> generateRandom(int n, int &l, double size) {

    vector <int> v;

    for (int i = 0; i < isqrt(n, 2); ++i) {
        v.push_back(randomValue(1, isqrt(l, 3)));
    }

    for (int i = isqrt(n, 2); i < n; ++i) {
        v.push_back(randomValue(1, isqrt(l, size)));
    }

    return v;
}

void generate(struct test t, int nr)
{ //generate test number nr
  string file = makeString(nr) + "-" + infile;
  freopen(file.c_str(), "w", stdout);

  printf("%d\n", t.t);

  while(t.t--) {

      int n = randomValue(t.n - isqrt(t.n, 2), t.n);
      int l = randomValue(t.l - isqrt(t.l, 2), t.l);
      vector <int> v;

      switch(randomValue(0, 2)) {
          case 0:
              v = generateRandom(n, l, 1.7);
              break;
          case 1:
              v = generateRandom(n, l, 1.4);
              break;
          case 2:
              v = generateBulan(n, l);
              break;
      }

      assert((int)v.size() == n);
      random_shuffle(v.begin(), v.end());

      printf("%d %d\n", n, l);

      for (size_t i = 0; i < v.size(); ++i) {
          assert(v[i] <= l);
          printf("%d ", v[i]);
      }

      printf("\n");
  }

  fclose(stdout);
}

int main()
{
  srand((unsigned)time(0));
  init();

  for(int i = 1; i <= nr; ++i)
    generate(t[i],i);

  return 0;
}
